﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.IO;
using System.Windows.Threading;
using System.Windows.Media.Imaging;

namespace GameProject
{
    public partial class MainPage : UserControl
    {
        private WriteableBitmap writeableBmp;
        private SeriTile.KeyHandler m_keyHandler = new SeriTile.KeyHandler();
        private DispatcherTimer m_gameLoopTimer;
        private DateTime m_lastTime = DateTime.Now;

        public MainPage()
        {
            InitializeComponent();
        }

        private void Init()
        {
            writeableBmp = new WriteableBitmap(768, 768);
            ImageControl.Source = writeableBmp;
          
            //Game Loop
            m_gameLoopTimer = new DispatcherTimer();
            m_gameLoopTimer.Interval = TimeSpan.Zero;
            m_gameLoopTimer.Tick += new EventHandler(m_gameLoopTimer_Tick);
            m_gameLoopTimer.Start();

            m_keyHandler.Attach(this);
            CompositionTarget.Rendering += new EventHandler(CompositionTarget_Rendering);
 
        }


        private void UserControl_Loaded(object sender, RoutedEventArgs e)
        {
            Init();
        }


        void m_gameLoopTimer_Tick(object sender, EventArgs e)
        {
            float deltaTime = ((DateTime.Now - m_lastTime).Milliseconds) / 1000.0f;
            m_lastTime = DateTime.Now;

            // Update logic goes here
        }

        void CompositionTarget_Rendering(object sender, EventArgs e)
        {

            writeableBmp.Clear(Colors.Black);

            try
            {
                // Drawing code goes here

                // Debug drawing test
                writeableBmp.DrawEllipse(20, 20, 200, 200, Colors.Purple);
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message + "\n" + ex.StackTrace);
            }
        }

        private void UserControl_KeyDown(object sender, KeyEventArgs e)
        {
            // Key checks go here
        }

        private void Image_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            // Clicks go here
        }

    }
}
