﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SeriTile
{
    public class IntPoint
    {
        public int X { get; set; }
        public int Y { get; set; }
        public IntPoint(int x, int y)
        {
            X = x;
            Y = y;
        }

        public IntPoint(Point point, int tileSize)
        {
            if (point.X < 0)
                X = (int)(point.X / tileSize);
            else
                X = (int)(point.X / tileSize);
            if (point.Y < 0)
                Y = (int)(point.Y / tileSize);
            else
                Y = (int)(point.Y / tileSize);

        }

        private IntPoint()
        {

        }

        public Point ToPoint(int tileSize)
        {
            return new Point((X + .5) * tileSize, (Y + .5) * tileSize);
        }

        public static bool operator ==(IntPoint a, IntPoint b)
        {
            // If both are null, or both are same instance, return true.
            if (System.Object.ReferenceEquals(a, b))
            {
                return true;
            }

            // If one is null, but not both, return false.
            if (((object)a == null) || ((object)b == null))
            {
                return false;
            }

            // Return true if the fields match:
            return a.X == b.X && a.Y == b.Y;
        }

        public static bool operator !=(IntPoint a, IntPoint b)
        {
            return !(a == b);
        }

        public override bool Equals(object obj)
        {
            return Equals(obj as IntPoint);
        }
        public bool Equals(IntPoint obj)
        {
            return obj == this;
        }


        public override int GetHashCode()
        {
            return X * 15000 + Y;
        }


    }
}
