﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SeriTile
{
    public class KeyHandler
    {
        bool[] isPressed = new bool[255];
        Control targetCanvas = null;
        public void ClearKeyPresses()
        {
            for (int i = 0; i < 255; i++)
            {
                isPressed[i] = false;
            }
        }

        public void Attach(Control target)
        {
            ClearKeyPresses();
            targetCanvas = target;
            target.KeyDown += new KeyEventHandler(target_KeyDown);
            target.KeyUp += new KeyEventHandler(target_KeyUp);
            target.LostFocus += new RoutedEventHandler(target_LostFocus);
        }


        public void Detach(Control target)
        {
            target.KeyDown -= new KeyEventHandler(target_KeyDown);
            target.KeyUp -= new KeyEventHandler(target_KeyUp);
            target.LostFocus -= new RoutedEventHandler(target_LostFocus);
            ClearKeyPresses();
        }

        void target_KeyDown(object sender, KeyEventArgs e)
        {
            if(e.Key != Key.Unknown)
                isPressed[(int)e.Key] = true;
        }

        void target_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key != Key.Unknown)
                isPressed[(int)e.Key] = false;
        }

        void target_LostFocus(object sender, RoutedEventArgs e)
        {
            ClearKeyPresses();
        }


        public bool IsKeyPressed(Key k)
        {
            int v = (int)k;
            if (v < 0 || v > 82) return false;
            return isPressed[v];
        }

    }

}
