﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Xml.Linq;

namespace SeriTile.RestHelper
{

    public class Rest
    {
        WebClient m_webClient;
        string m_uri;
        private string m_method;
        public delegate void OnResponseHandler(Rest sender, XElement response);
        public OnResponseHandler OnResponse;

        public Rest(string serviceURL, string service, string method)
        {
            m_webClient = new WebClient();
            m_method = method;
            m_uri = serviceURL + service + ".php?method=" + method;
            m_webClient.DownloadStringCompleted += new DownloadStringCompletedEventHandler(m_webClient_DownloadStringCompleted);
        }

        void m_webClient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (OnResponse != null)
            {
                XDocument doc = XDocument.Parse(e.Result);
                XElement response = doc.Root.Element(m_method).Element("response");

                OnResponse(this, response);
            }
        }

        public void AddParameter(string paramName, string paramValue)
        {
            m_uri += "&" + System.Windows.Browser.HttpUtility.UrlEncode(paramName) + "=" + System.Windows.Browser.HttpUtility.UrlEncode(paramValue);
        }

        public void Submit()
        {
            m_webClient.DownloadStringAsync(new Uri(m_uri));
        }
    }
}
