﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace SeriTile
{
    public class Tile:ITile
    {
        private Rect m_rect;
        private WriteableBitmap m_image;
        private Point m_offset;
        private WriteableBitmapExtensions.BlendMode m_blendMode;

        public Tile(Rect rect, WriteableBitmap image, WriteableBitmapExtensions.BlendMode blendMode)
        {
            m_rect = rect;
            m_image = image;
            m_blendMode = blendMode;
        }

        public Tile(Rect rect, Point offset, WriteableBitmap image, WriteableBitmapExtensions.BlendMode blendMode)
        {
            m_rect = rect;
            m_image = image;
            m_offset = offset;
            m_blendMode = blendMode;
        }

        public override Rect Rect
        {
            get
            {
                return m_rect;
            }
        }

        public override Point Offset
        {
            get
            {
                return m_offset;
            }
        }

        public override WriteableBitmap Image
        {
            get
            {
                return m_image;
            }

        }
        public override WriteableBitmapExtensions.BlendMode BlendMode
        {
            get
            {
                return m_blendMode;
            }
            internal set
            {
                m_blendMode = value;
            }
        }

        public override void Blit(WriteableBitmap bitmap, Point blitPoint)
        {
            bitmap.Blit(blitPoint, Image, Rect, Colors.White, BlendMode);
        }

        public override void Blit(WriteableBitmap bitmap, Point blitPoint, Color color)
        {
            bitmap.Blit(blitPoint, Image, Rect, color, BlendMode);
        }
    }
}
