﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace SeriTile
{
    public class TintedTile: ITile
    {
        ITile m_baseTile;
        Color m_tint;

        public TintedTile(ITile baseTile, Color tint)
        {
            m_baseTile = baseTile;
            m_tint = tint;
        }

        public override Rect Rect 
        {
            get
            {
                return m_baseTile.Rect;
            }
        }
        public override Point Offset 
        {
            get
            {
                return m_baseTile.Offset;
            }
        }

        public override WriteableBitmap Image 
        {
            get
            {
                return m_baseTile.Image;
            }
        }

        public override WriteableBitmapExtensions.BlendMode BlendMode 
        {
            get
            {
                return m_baseTile.BlendMode;
            }
            internal set
            {
                m_baseTile.BlendMode = value;
            }
        }

        public override void Blit(WriteableBitmap bitmap, Point blitPoint)
        {
            bitmap.Blit(blitPoint, m_baseTile.Image, m_baseTile.Rect, m_tint, m_baseTile.BlendMode);
        }

        public override void Blit(WriteableBitmap bitmap, Point blitPoint, Color color)
        {
            bitmap.Blit(blitPoint, Image, Rect, color, BlendMode);
        }
    }
}
